﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using InTheHand;
using InTheHand.Net.Bluetooth;
using InTheHand.Net.Ports;
using InTheHand.Net.Sockets;
using System.IO;

namespace Senior_Phonebook
{
    public partial class Form1 : Form
    {
        public static Stream mStream;
        public static int BluetoothStatus = 0;

        public Form1()
        {
            InitializeComponent();
            
            if (BluetoothStatus == 1)
            {
                ConnectionStatus_lb.Text = "Connected";
                bluetooth_btn.Visible = false;
                bluetooth_btn.Enabled = false;
                call_button.Enabled = true;
                admin_button.Enabled = true;
            }

        }


        /****************************************************************
        Button used to enter the Call/Contacts form
        *****************************************************************/
        private void call_button_Click(object sender, EventArgs e)
        {
            this.Hide();
            Form2 form2 = new Form2();
            form2.Closed += (s, args) => this.Close();
            form2.Show();
            
        }

        /****************************************************************
        Close button
        *****************************************************************/
        private void close_button_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /****************************************************************
        Admin button used to access the admin login form
        *****************************************************************/
        private void admin_button_Click(object sender, EventArgs e)
        {
            this.Hide();
            Form3 form3 = new Form3();
            form3.Closed += (s, args) => this.Close();
            form3.Show();
        }

        Guid mUUID = new Guid("00001101-0000-1000-8000-00805F9B34FB");          // UUID for most bluetooth devices "00001101-0000-1000-8000-00805F9B34FB"
                                                                                // UUID from UUID generator        "7d74b9c8-7e85-4485-9863-deca8a4ccb4b"

        /****************************************************************
        Bluetooth button used to start the server side of the
        blutooth connection, then waits for a client(phone) to connect
        *****************************************************************/
        private void bluetooth_btn_Click(object sender, EventArgs e)
        {
            Thread bluetoothServerThread = new Thread(new ThreadStart(ServerConnectThread));
            bluetoothServerThread.Start();

            bluetooth_btn.Enabled = false;
        }


        /****************************************************************
        This is the created thread that waits for a client(phone) to 
        connect, then changed the UI to let the user know the phone
        has connected
        *****************************************************************/
        public void ServerConnectThread()
        {
            ConnectionStatus_lb.Text = "Waiting for phone to connect...";
            BluetoothListener blueListener = new BluetoothListener(mUUID);
            blueListener.Start();
            BluetoothClient conn = blueListener.AcceptBluetoothClient();
            ConnectionStatus_lb.Text = "Connected";

            
            BluetoothStatus = 1;

            bluetooth_btn.Visible = false;
            bluetooth_btn.Enabled = false;
            call_button.Enabled = true;
            //admin_button.Enabled = true;

            mStream = conn.GetStream();
        }

    }
}
