﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Resources;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace Senior_Phonebook
{
    public partial class Form2 : Form
    {
        //Setting up server parameters
        string serverIP = "localhost";
        int port = 8080;
        
        //Some public variables that store contact names, phonenumber, picture file paths
        //used in most functions
        public string[] gname = new string[6];
        public string[] gphone = new string[6];
        public string[] gFilePaths = new string[6];

        public static string gFilePath = null;
        public static string sFilePath
        {
            get { return gFilePath; }
        }
        public static string calling;
        public static string sCalling
        {
            get { return calling; }
        }
        public static string phonenumber = null;
        public static string sphonenumber
        {
            get { return phonenumber; }
        }
        public static bool answered = false;
        public static bool sAnswered
        {
            get { return answered; }
        }
        
        //************Volume Controls*************//
        private const int APPCOMMAND_VOLUME_MUTE = 0x80000;
        private const int APPCOMMAND_VOLUME_UP = 0xA0000;
        private const int APPCOMMAND_VOLUME_DOWN = 0x90000;
        private const int WM_APPCOMMAND = 0x319;

        public Form2()
        {
            InitializeComponent();

            //Determining if user is an Admin, if they are an admin
            //they are given access to edit options for images, names, numbers, etc.
            if (Form3.admin == true)
            {
                this.edit1_button.Visible = true;
                this.edit2_button.Visible = true;
                this.edit3_button.Visible = true;
                this.edit4_button.Visible = true;
                this.edit5_button.Visible = true;
                this.edit6_button.Visible = true;
                this.upload1_button.Visible = true;
                this.upload2_button.Visible = true;
                this.upload3_button.Visible = true;
                this.upload4_button.Visible = true;
                this.upload5_button.Visible = true;
                this.upload6_button.Visible = true;
                this.toggle_emer_button.Visible = true;
                this.pictureBox1.Enabled = false;
                this.pictureBox2.Enabled = false;
                this.pictureBox3.Enabled = false;
                this.pictureBox4.Enabled = false;
                this.pictureBox5.Enabled = false;
                this.pictureBox6.Enabled = false;
                this.loud_button.Enabled = false;
                this.quiet_button.Enabled = false;
            }
            else
            {
                this.edit1_button.Visible = false;
                this.edit2_button.Visible = false;
                this.edit3_button.Visible = false;
                this.edit4_button.Visible = false;
                this.edit5_button.Visible = false;
                this.edit6_button.Visible = false;
                this.upload1_button.Visible = false;
                this.upload2_button.Visible = false;
                this.upload3_button.Visible = false;
                this.upload4_button.Visible = false;
                this.upload5_button.Visible = false;
                this.upload6_button.Visible = false;
                this.toggle_emer_button.Visible = false;
                this.pictureBox1.Enabled = true;
                this.pictureBox2.Enabled = true;
                this.pictureBox3.Enabled = true;
                this.pictureBox4.Enabled = true;
                this.pictureBox5.Enabled = true;
                this.pictureBox6.Enabled = true;
                this.loud_button.Enabled = true;
                this.quiet_button.Enabled = true;
            }
            
            //***************Get image file paths***********************//
            FileStream input = new FileStream("ImageFilePaths.txt", FileMode.Open, FileAccess.Read);
            StreamReader filereader = new StreamReader(input);
            string[] path = new string[] { "", "", "", "", "", "" };
            for(int i = 0; i <= 5; i++)
            {
                path[i] = filereader.ReadLine();
                gFilePaths[i] = path[i];
            }
            filereader.Close();
            input.Close();

            if (path[0] != "" && path[0] != null)
                pictureBox1.Image = new Bitmap(path[0]);
            if (path[1] != "" && path[1] != null)
                pictureBox2.Image = new Bitmap(path[1]);
            if (path[2] != "" && path[2] != null)
                pictureBox3.Image = new Bitmap(path[2]);
            if (path[3] != "" && path[3] != null)
                pictureBox4.Image = new Bitmap(path[3]);
            if (path[4] != "" && path[4] != null)
                pictureBox5.Image = new Bitmap(path[4]);
            if (path[5] != "" && path[5] != null)
                pictureBox6.Image = new Bitmap(path[5]);
                
            //**************Emergency button toggle***********************//
            input = new FileStream("EmergencyButton.txt", FileMode.Open, FileAccess.Read);
            filereader = new StreamReader(input);
            string emerBool = filereader.ReadLine();
            if (emerBool == "1")
            {
                emergency_button.Visible = false;
                toggle_emer_button.Text = "<-- Enable 911 button";
            }
            filereader.Close();
            input.Close();

            //**************Get name and numbers for picture labels**************//
            input = new FileStream("Name_Phonenumber.txt", FileMode.Open, FileAccess.Read);
            filereader = new StreamReader(input);
            string[] names = new string[] { "", "", "", "", "", "" };
            string[] numbers = new string[] { "", "", "", "", "", "" };
            for (int i = 0; i <= 5; i++)
            {
                var temp = filereader.ReadLine();
                if (temp != "" && temp != null)
                {
                    string[] info = temp.Split(';');
                    names[i] = info[0];
                    numbers[i] = info[1];
                }
            }
            filereader.Close();
            input.Close();

            for (int i = 0; i <= 5; i++)
            {
                gname[i] = names[i];
                gphone[i] = numbers[i];
            }

            name1_lb.Text = names[0];
            phone1_lb.Text = numbers[0];
            name2_lb.Text = names[1];
            phone2_lb.Text = numbers[1];
            name3_lb.Text = names[2];
            phone3_lb.Text = numbers[2];
            name4_lb.Text = names[3];
            phone4_lb.Text = numbers[3];
            name5_lb.Text = names[4];
            phone5_lb.Text = numbers[4];
            name6_lb.Text = names[5];
            phone6_lb.Text = numbers[5];
        }

        /****************************************************************
        First, determines what picture was clicked
        Second, establishes socket connection with server (if server is running)
        Third, based on server response ("answer" or "decline")   (anything that is not "answer" is treated as "decline" as well)
               if "answer" opens form6 (calling form)
               else "decline", currently shows a message box that says "declined"
        *****************************************************************/
        private void pictureBox1_Click(object sender, EventArgs e)
        {
            answered = false;
            //FileStream input = new FileStream("Name_Phonenumber.txt", FileMode.Open, FileAccess.Read);
            //StreamReader filereader = new StreamReader(input);
            //string[] names = new string[] { "", "", "", "", "", "" };
            //string[] numbers = new string[] { "", "", "", "", "", "" };
            //for (int i = 0; i <= 5; i++)
            //{
            //    var temp = filereader.ReadLine();
            //    if (temp != "" && temp != null)
            //    {
            //        string[] info = temp.Split(';');
            //        names[i] = info[0];
            //        numbers[i] = info[1];
            //    }
            //}
            //filereader.Close();
            //input.Close();

            int x = 0;
            string bttn = ((PictureBox)sender).Name;
            if (bttn == pictureBox1.Name)
            {
                x = 0;
            }
            else if (bttn == pictureBox2.Name)
            {
                x = 1;
            }
            else if (bttn == pictureBox3.Name)
            {
                x = 2;
            }
            else if (bttn == pictureBox4.Name)
            {
                x = 3;
            }
            else if (bttn == pictureBox5.Name)
            {
                x = 4;
            }
            else if (bttn == pictureBox6.Name)
            {
                x = 5;
            }

            if (gphone[x] != "" && gphone[x] != null)
            {
                //*************SOCKETS*****************//

                //TcpClient client = new TcpClient(serverIP, port);///////////////////////////////////////////////

                //int byteCount = Encoding.ASCII.GetByteCount(gphone[x] + 1);

                //byte[] Data = new byte[byteCount];

                //Data = Encoding.ASCII.GetBytes(gphone[x] + ";");

                //NetworkStream stream = client.GetStream();

                //stream.Write(Data, 0, Data.Length);

                //Data = new byte[256];
                //string responceData = string.Empty;/////////////////////////////////////////////////////////////

                //***************************************
                phonenumber = gphone[x];
                gFilePath = gFilePaths[x];
                calling = gname[x];
                Form6 form6 = new Form6();
                form6.ShowDialog();
                //***************************************/

                //stream.Read(Data, 0, Data.Length);///////////////////////////////////////////////////////////

                /****HERE** ///
                Int32 bytes = stream.Read(Data, 0, Data.Length);
                responceData = System.Text.Encoding.ASCII.GetString(Data, 0, bytes);
                //**HERE****///

                //StringBuilder call = new StringBuilder();//////////////////////////////////////////////////////

                //foreach(byte b in Data)
                //{
                //    if (b.Equals(00))
                //        break;
                //    else
                //        call.Append(Convert.ToChar(b).ToString());
                //}

                //responceData = call.ToString();

                //gFilePath = gFilePaths[x];
                //calling = gname[x];

                //if (responceData == "answer")
                //{
                //    Form6 form6 = new Form6();
                //    form6.Show();
                //    answered = true;
                //}
                //else
                //{
                //    MessageBox.Show("declined");
                //}


                //stream.Close();
                //client.Close();//////////////////////////////////////////////////////////////////////////////////

            }
            else
                MessageBox.Show("No phonenumber was found for this Person.");

        }

        /****************************************************************
        Event occures on back_button click, event name was not changed...
        closes the call/contacts form and returns to the main form1
        *****************************************************************/
        private void button1_Click(object sender, EventArgs e)
        {
            Form3.admin = false;
            this.Hide();
            Form1 form1 = new Form1();
            form1.Closed += (s, args) => this.Close();
            form1.Show();
        }

        /****************************************************************
        Increase volume
        *****************************************************************/
        private void loud_button_Click(object sender, EventArgs e)
        {
            //int temp = Convert.ToInt32(volume_label.Text);
            //temp++;
            //if (temp > 100)
            //    temp = 100;
            //volume_label.Text = temp.ToString();
            byte[] makeLoud = Encoding.ASCII.GetBytes("VOLUME_UP");
            Form1.mStream.Write(makeLoud, 0, makeLoud.Length);
        }

        /****************************************************************
        Decrease volume
        *****************************************************************/
        private void quiet_button_Click(object sender, EventArgs e)
        {
            //int temp = Convert.ToInt32(volume_label.Text);
            //temp--;            //if (temp < 0)
            //    temp = 0;
            //volume_label.Text = temp.ToString();
            byte[] makeQuite = Encoding.ASCII.GetBytes("VOLUME_DOWN");
            Form1.mStream.Write(makeQuite, 0, makeQuite.Length);
        }

        /****************************************************************
        I don't believe these next two events are relevant, I used them when
        trying to make admin = false when the admin left the call/contact form (form2)
        but that is now taken care of on the button1_click event (back_button onClick)
        *****************************************************************/
        private void Form2_FormClosed(object sender, FormClosedEventArgs e)
        {
            Form3.admin = false;
        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {
            Form3.admin = false;
        }
        /******************************************************************/

        /****************************************************************
        Edit button, only available when form is accessed by an admin.
        Allows the admin to change/update/add a contact Name and Number
        and immediatly changes the text on the form, and saves the new 
        information to the textfile
        *****************************************************************/
        private void edit1_button_Click(object sender, EventArgs e)
        {
            //Form5 form5 = new Form5();
            //form5.Show();
            string name = "";
            string phone = "";

            using (Form5 form = new Form5())
            {
                var result = form.ShowDialog();
                if (result == DialogResult.OK)
                {
                    name = form.newName;
                    phone = form.newPhone;
                }
            }

            int x = 0;
            string bttn = ((Button)sender).Name;
            if (bttn == edit1_button.Name)
            {
                x = 0;
                name1_lb.Text = name;
                phone1_lb.Text = phone;
            }
            else if (bttn == edit2_button.Name)
            {
                x = 1;
                name2_lb.Text = name;
                phone2_lb.Text = phone;
            }
            else if (bttn == edit3_button.Name)
            {
                x = 2;
                name3_lb.Text = name;
                phone3_lb.Text = phone;
            }
            else if (bttn == edit4_button.Name)
            {
                x = 3;
                name4_lb.Text = name;
                phone4_lb.Text = phone;
            }
            else if (bttn == edit5_button.Name)
            {
                x = 4;
                name5_lb.Text = name;
                phone5_lb.Text = phone;
            }
            else if (bttn == edit6_button.Name)
            {
                x = 5;
                name6_lb.Text = name;
                phone6_lb.Text = phone;
            }

            FileStream input = new FileStream("Name_Phonenumber.txt", FileMode.Open, FileAccess.Read);
            StreamReader filereader = new StreamReader(input);
            string[] names = new string[] { "", "", "", "", "", "" };
            string[] numbers = new string[] { "", "", "", "", "", "" };
            for (int i = 0; i <= 5; i++)
            {
                var temp = filereader.ReadLine();
                if (temp != "" && temp != null)
                {
                    string[] info = temp.Split(';');  
                    names[i] = info[0];
                    numbers[i] = info[1];
                }
            }
            filereader.Close();
            input.Close();

            //MessageBox.Show(names[0] + " " + names[1] + " " + names[4]);
            // MessageBox.Show(numbers[0] + " " + numbers[1] + " " + numbers[4]);

            names[x] = name;
            numbers[x] = phone;

            FileStream output = new FileStream("Name_Phonenumber.txt", FileMode.Truncate, FileAccess.Write);
            StreamWriter filewriter = new StreamWriter(output);
            for (int i = 0; i < 5; i++)
            {
                string temp = names[i] + ";" + numbers[i];
                filewriter.WriteLine(temp);
            }
            filewriter.Write(names[5] + ";" + numbers[5]);
            filewriter.Close();
            output.Close();


        }

        /****************************************************************
        Same as Edit, Upload is only accessible by an admin.
        Used to upload an image to the picture box.
        The picturebox is immediatly updated, and the pictures file path
        will be saved in the textfile
        *****************************************************************/
        private void upload1_button_Click(object sender, EventArgs e)
        {
            OpenFileDialog file = new OpenFileDialog();
            file.Filter = "Image Files(*.jpg; *.jpeg; *.gif; *.bmp)|*.jpg; *.jpeg; *.gif; *.bmp";
            if(file.ShowDialog() == DialogResult.OK)
            {
                int x = 0;
                string bttn = ((Button)sender).Name;
                if (bttn == upload1_button.Name)
                {
                    pictureBox1.Image = new Bitmap(file.FileName);
                    x = 0;


                }
                else if (bttn == upload2_button.Name)
                {
                    pictureBox2.Image = new Bitmap(file.FileName);
                    x = 1;
                    

                }
                else if (bttn == upload3_button.Name)
                {
                    pictureBox3.Image = new Bitmap(file.FileName);
                    x = 2;
                    

                }
                else if (bttn == upload4_button.Name)
                {
                    pictureBox4.Image = new Bitmap(file.FileName);
                    x = 3;
                    

                }
                else if (bttn == upload5_button.Name)
                {
                    pictureBox5.Image = new Bitmap(file.FileName);
                    x = 4;
                    

                }
                else if (bttn == upload6_button.Name)
                {
                    pictureBox6.Image = new Bitmap(file.FileName);
                    x = 5;

                }

                FileStream input = new FileStream("ImageFilePaths.txt", FileMode.Open, FileAccess.Read);
                StreamReader filereader = new StreamReader(input);
                string[] path = new string[] { "", "", "", "", "", "" };
                for (int i = 0; i < 6; i++)
                {
                    path[i] = filereader.ReadLine();
                }
                filereader.Close();
                input.Close();

                path[x] = file.FileName;

                FileStream output = new FileStream("ImageFilePaths.txt", FileMode.Truncate, FileAccess.Write);
                StreamWriter filewriter = new StreamWriter(output);
                for (int i = 0; i < 5; i++)
                {
                    filewriter.WriteLine(path[i]);
                }
                filewriter.Write(path[5]);
                filewriter.Close();
                output.Close();
            }
        }

        /****************************************************************
        This button opens form4, witch is the emergency form that allows
        the user to call 911.
        *****************************************************************/
        private void emergency_button_Click(object sender, EventArgs e)
        {
            this.Hide();
            Form4 form4 = new Form4();
            form4.Closed += (s, args) => this.Close();
            form4.Show();
        }

        /****************************************************************
        Like Edit and Upload, this button is also only avialable to admins.
        This button is a toggle of the emergency button, it allows
        the admin to disable or enable the emergency button.
        *****************************************************************/
        private void toggle_emer_button_Click(object sender, EventArgs e)
        {
            FileStream input = new FileStream("EmergencyButton.txt", FileMode.Open, FileAccess.Read);
            StreamReader filereader = new StreamReader(input);
            string emerBool = filereader.ReadLine();
            if(emerBool == "0")
            {
                emerBool = "1";
                emergency_button.Visible = false;
                toggle_emer_button.Text = "<-- Enable 911 button";
            }
            else if(emerBool == "1")
            {
                emerBool = "0";
                emergency_button.Visible = true;
                toggle_emer_button.Text = "<-- Disable 911 button";
            }
            filereader.Close();
            input.Close();
            FileStream output = new FileStream("EmergencyButton.txt", FileMode.Open, FileAccess.Write);
            StreamWriter filewriter = new StreamWriter(output);
            filewriter.Write(emerBool);
            filewriter.Close();
            output.Close();
        }
    }
}
